Foreman - Bug #14410

Failure to run DB migrations prevents plugin permissions being loaded
03/31/2016 02:37 AM - Daniel Lobato Garcia

Status: Closed
Priority: Normal
Assignee: Daniel Lobato Garcia
Category: DB migrations
Target version: 1.13.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1221971 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3426,
https://github.com/theforeman/foreman/p
ull/3561
Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1221971
Description of problem:

Version-Release number of selected component (if applicable):
How reproducible:

Steps to Reproduce:

1. configure LDAP authentication using http://theforeman.org/manuals/1.8/index.html#4.1.1 LDAPAuthentication
2. create a user-group with external user-group (example Active Directory)

3. login as a AD user, which is part of the external user-group

4. create a ak_role via the roles and assign all the "activation keys" permissions via the filters.

5. assign the role "ak_role" at the user_group level(only after step 3) performed to reproduce)

Actual results:

login as a AD user, which is part of the external user-group, to observe that the AD user has no access/permissions for all the roles
added after the AD user was logged in.

Expected results:

Adding new roles for the AD user at user-group level after the AD user was logged-id should be possible.

Additional info:

Related issues:
Related to Foreman - Refactor #15866: Provide alternative way of migrating da... New 07/27/2016

Associated revisions

Revision 2aa15bf1 - 07/01/2016 09:45 AM - Ivan Necas
Fixes #14410 - respond 503 when pending migration

History

#1 - 03/31/2016 03:19 AM - Dominic Cleal
- Category set to Users, Roles and Permissions

- Status changed from New to Need more information

Does the user have the groups? Please try on a current version and provide logs with LDAP debugging enabled.

#2 - 04/04/2016 10:40 AM - Daniel Lobato Garcia

- Project changed from Foreman to Katello
- Category deleted (Users, Roles and Permissions)

- Status changed from Need more information to Assigned

Yeah, the user has the groups. The problem I'm facing is that Katello links are not being displayed even though the user has the appropriate
permissions. I'll move this to the Katello project.

#3 - 04/04/2016 10:53 AM - Daniel Lobato Garcia

It doesn't have to do much with group permissions either | don't think. Even if | set the view_activation_keys permission to the user directly, it doesn't
work.

#4 - 04/05/2016 08:53 AM - Daniel Lobato Garcia

- Subject changed from adding new roles at user_group level after user logs in seems to have no effect to Adding activation_keys permissions to user
seems to have no effect

#5 - 04/06/2016 06:58 AM - Daniel Lobato Garcia
It has to deal somehow with the way permissions are loaded.

On a production nightly host: “Foreman::AccessControl.send(:permissions).map(&:name).count’ -> 161 - it's missing Katello permissions
On a katello-deploy centos7-devel host: “Foreman::AccessControl.send(:permissions).map(&:name).count™ -> 238 - bug can't be reproduced

#6 - 04/13/2016 12:37 PM - Daniel Lobato Garcia

- Project changed from Katello to Foreman

Ah, finally found the cause. It doesn't have to do with external user groups as far as | can see. You'll probably struggle to reproduce this one, as it
requires:

e Upgrading from some verison
e Fail during the upgrade so that some migration does not run

At that point, Foreman::AccessControl does not load the permissions from plugins properly, as per line
https://github.com/theforeman/foreman/blob/develop/app/services/foreman/plugin.rb#L 217

If you run foreman-rake db:migrate and systemctl restart httpd, permissions will be reloaded again and it will work.
So | guess we should either log this better or turn on the check for missing migrations in production. (
https://qist.github.com/stbenjam/c182ff0b1fe99bef6680ea4463f1f156)

#7 - 04/14/2016 06:23 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3426 added

#8 - 05/31/2016 10:04 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/3561 added

#9 - 05/31/2016 10:08 AM - Dominic Cleal
- Priority changed from High to Normal

- Subject changed from Adding activation_keys permissions to user seems to have no effect to Failure to run DB migrations prevents plugin
permissions being loaded

- Category set to DB migrations

#10 - 07/01/2016 10:02 AM - lvan Necas
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 2aa15bf1f40fff77a50bb9907fa993e067dd6346.

#11 - 07/04/2016 05:02 AM - Dominic Cleal

- translation missing: en.field_release set to 160

#12 - 07/27/2016 12:08 PM - Ivan Necas

- Related to Refactor #15866: Provide alternative way of migrating data as oposed misuing db:migrate for this purpose added
